#procedure gramsubstitution(N,w)

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** It substitutes one of the elements to match posssible Gram determinants
** begun on 12.03.04

** Adjusting the partner element to acompany the substituted one for N=3
*-------------------------------------------------------------------------------
** For order 2 Gram determinants

#if `N' == 2
 #if     `w' == 1
  #define bigterm "dummy3(a1?,a2?,a3?)"
  #define smaterm "dummy3(a1-2,a2,a3)"
 #elseif `w' == 2
  #define bigterm "dummy3(a1?,a2?,a3?)"
  #define smaterm "dummy3(a1,a2-2,a3)"
 #elseif `w' == 3
  #define bigterm "dummy3(a1?,a2?,a3?)"
  #define smaterm "dummy3(a1,a2,a3-2)"
 #endif

 if ($b`w' >=2);
*  Print "The variables are: %$",$var`w';
  id `bigterm'=`smaterm'*(-2*[Gram2] + $var`w'^2
       - $var1^2 
       - $var2^2 
       - $var3^2 
       + 2*$var1*$var2
       + 2*$var1*$var3
       + 2*$var2*$var3
       );
  #call vartodummy(`N')
 endif;

*-------------------------------------------------------------------------------
** For order 3 Gram determinants

#elseif `N' == 3
 #if     `w' == 1
  #define wp "3"
  #define bigterm "dummy6(a1?,a2?,a3?,a4?,a5?,a6?)"
  #define smaterm "dummy6(a1-2,a2,a3-1,a4,a5,a6)"
  #define resterm "dummy6(2,0,1,0,0,0)"
 #elseif `w' == 2
  #define wp "4"
  #define bigterm "dummy6(a1?,a2?,a3?,a4?,a5?,a6?)"
  #define smaterm "dummy6(a1,a2-2,a3,a4-1,a5,a6)"
  #define resterm "dummy6(0,2,0,1,0,0)"
 #elseif `w' == 3
  #define wp "1"
  #define bigterm "dummy6(a1?,a2?,a3?,a4?,a5?,a6?)"
  #define smaterm "dummy6(a1-1,a2,a3-2,a4,a5,a6)"
  #define resterm "dummy6(1,0,2,0,0,0)"
 #elseif `w' == 4
  #define wp "2"
  #define bigterm "dummy6(a1?,a2?,a3?,a4?,a5?,a6?)"
  #define smaterm "dummy6(a1,a2-1,a3,a4-2,a5,a6)"
  #define resterm "dummy6(0,1,0,2,0,0)"
 #elseif `w' == 5
  #define wp "6"
  #define bigterm "dummy6(a1?,a2?,a3?,a4?,a5?,a6?)"
  #define smaterm "dummy6(a1,a2,a3,a4,a5-2,a6-1)"
  #define resterm "dummy6(0,0,0,0,2,1)"
 #elseif `w' == 6
  #define wp "5"
  #define bigterm "dummy6(a1?,a2?,a3?,a4?,a5?,a6?)"
  #define smaterm "dummy6(a1,a2,a3,a4,a5-1,a6-2)"
  #define resterm "dummy6(0,0,0,0,1,2)"
 #endif

 if ($b`w' >=2 && $b`wp' >= 1);
*  Print "The variables are: %$,%$",$var`w',$var`wp';
  id `bigterm'=`smaterm'*(-2*[Gram3] + $var`w'^2*$var`wp'
       + $var1*$var2*$var3
       + $var1*$var2*$var4
       - $var1*$var2*$var5
       + $var1*$var3*$var4
       + $var1*$var3*$var5
       + $var1*$var3*$var6
       - $var1*$var3^2
       - $var1*$var4*$var6
       + $var1*$var5*$var6
       - $var1^2*$var3
       + $var2*$var3*$var4
       - $var2*$var3*$var6
       + $var2*$var4*$var5
       + $var2*$var4*$var6
       - $var2*$var4^2
       + $var2*$var5*$var6
       - $var2^2*$var4
       - $var3*$var4*$var5
       + $var3*$var5*$var6
       + $var4*$var5*$var6
       - $var5*$var6^2
       - $var5^2*$var6
       );
  #call vartodummy(`N')
 endif;
#endif

*id acc(a?)=a;

#endprocedure
*$Id: gramsubstitution.prc,v 1.5 2004/10/08 14:28:11 alorca Exp $
