#procedure simplifygrams()

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** It tries to remove Inverse Gram determinants by looking to the numerator
** Begun on 10.12.03

** the strategy is to check in each block with similar IGram, whether it is 
** possible to make substitution in the one of the terms
** in order to match exactly other terms.
#call massconvention
argument IGram;
 #call massconvention()
endargument;
*-------------------------------------------------------------------------------
** For order 3 Gram determinants

#define jump3 "0"
#if `jump3' == 0

#define N "3"
#message [simplifygrams: Trying to match order `N' inverse Gram determinants]
#$substitutions=0;
if (match(IGram(`N',MMle?$var1,MMt?$var2,MMc?$var3,MMlm?$var4,sman?$var5,tman?$var6)));
 #call vartodummy(`N')
endif;
#$counter=0;

*id IGram(?a)^2=IGram(?a)*IGramcopy(?a);

ab dummy6;
*print +s;
.sort
CF Gram;
Collect acc;

if (match(IGram(`N',MMle?$var1,MMt?$var2,MMc?$var3,MMlm?$var4,sman?$var5,tman?$var6)));
 $counter=$counter+1;
** Because they get ordered only two terms are enough to pick the most Grams...
 #call analyzeterms(`N',acc,6)
 Print "[%$] substitutions on [%$] Gram`N' inv dets",$substitutions,$counter;
 id acc(a1?)=a1;
 #call dummytovar(`N')
* id [Gram`N']*IGram(`N',$var1,$var2,$var3,$var4,$var5,$var6)=1;
* id 1/IGram(`N')=Gram(`N',$var1,$var2,$var3,$var4,$var5,$var6);
* id IGram(`N',?a)/IGram(`N')=1;
endif;
id acc(a1?)=a1;
.sort
*id IGram(`N',?a)*Gram(`N',?b)=1;

#endif
*-------------------------------------------------------------------------------
** For order 2 Gram determinants

#define jump2 "0"
#if `jump2' == 0
 #redefine N "2"
 #message [simplifygrams: Trying to match order `N' inverse Gram determinants]
 #$substitutions=0;
if (match(IGram(`N',MMle?$var1,MMt?$var2,sman?$var3)));
 #call vartodummy(`N')
endif;
 #$counter=0;
ab dummy3;
*print +s;
.sort
Collect acc;
if (match(IGram(`N',MMle?$var1,MMt?$var2,sman?$var3)));
 $counter=$counter+1;
** Because they get ordered only two terms are enough to pick the most Grams...
 #call analyzeterms(`N',acc,4)
 Print "[%$] substitutions on [%$] Gram`N' inv dets",$substitutions,$counter;
 id acc(a1?)=a1;
 #call dummytovar(`N')
* id [Gram`N']*IGram(`N',$var1,$var2,$var3)=1;
* id 1/IGram(`N')=Gram(`N',$var1,$var2,$var3);
endif;
id acc(a1?)=a1;
.sort
*id once IGram(`N',?a)*Gram(`N')=1;
#endif

*-------------------------------------------------------------------------------
** For order 1 Gram determinants
** Trivial simplification for Gram of order1;

id IGram(1,a?!{MMA})=1/(2*a);
id IGram(1,a?!{MA}^b?)*a?^b?=1/(2*a^b);
*id IGram(1,a?)=1/(2*a);
*-------------------------------------------------------------------------------
.sort
* Final replacements

id IGram(2,?a)*Gram(2,?b)=1;
id IGram(3,?a)*Gram(3,?b)=1;


#endprocedure
*$Id: simplifygrams.prc,v 1.6 2004/10/08 14:28:12 alorca Exp $

